#
# ImagesManagerWidget by Martin Aspeli <optilude@gmx.net>
#

from Products.Archetypes.Widget import TypesWidget
from Products.Archetypes.Registry import registerWidget

class ImagesManagerWidget (TypesWidget):
    """This widget is a little bit of a hack. ;-)

    This widget adds support for uploading images into documents. To support
    this, you must use it on a folderish type (derived from BaseFolder) with
    'Image' in the allowed_content_types. Create an IntegerField and use
    this widget. This will display a form at the bottom of your base_edit
    (presuming it's the last widget, which it probably ought to be) where you
    can upload images into your content type. You can also choose whether to
    display an images preview on the view template. There are three modes,
    corresponding to the value of the IntergerField:
    
        0   -   No preview
        1   -   Preview the first image, floating at the top left
        2   -   Show a box of thumbnails of the uploaded images
    
    You probably want to provide a vocabulary to manage these on the field.
    
    Content editors may also reference the images direcctly in their body
    text.
    
    Caveats: This may not work so well with portal_factory. Experiment. Also,
    to make the preview look good, you'll probably need to provide a custom
    base_view body macro for your type. Finally, in the edit macro, the upload
    button may steal the default enter-key-press in base_edit.
    """

    _properties = TypesWidget._properties.copy ()
    _properties.update ({   'macro'             : 'widget_imagesmanager',
                            'helper_js'         : ('widget_imagesmanager.js',),
                            'helper_css'        : ('widget_imagesmanager.css',),
                         },)

registerWidget (ImagesManagerWidget,
                title = 'Images manager widget',
                description= ('Renders controls for uploading images in documents',),
                used_for = ('Products.Archetypes.Field.IntegerField',)
                )
