# File: RichDocument.py
"""\
A document type which may contain directly uploaded images.

RCS-ID $Id: RichDocument.py,v 1.1.1.1 2005/01/09 18:50:26 optilude Exp $
"""
# Copyright (c) 2005 by Copyright (c) 2005 Martin Aspeli
#
# Generated: Sun Jan  9 00:40:32 2005
# Generator: ArchGenXML Version 1.2 devel 1 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = 'Martin Aspeli <optilude@gmx.net>'
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *


# additional imports
from ImagesManagerWidget import ImagesManagerWidget
##code-section module-header #fill in your manual code here
##/code-section module-header


class RichDocument(OrderedBaseFolder):
    """
    A document type which may contain directly uploaded images.
    """
    security = ClassSecurityInfo()
    portal_type = meta_type = 'RichDocument' 
    archetype_name = 'Rich document'   #this name appears in the 'add' box 
    allowed_content_types = ['Image'] 

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    schema=BaseFolderSchema  + Schema((
        StringField('title',
            accessor="""Title""",
            required=1,
            searchable=1,
            widget=StringWidget
            (description="""""",
                description_msgid='RichDocument_help_title',
                i18n_domain='RichDocument',
                label="""Title""",
                label_msgid='RichDocument_label_title',
            ),
        ),
        
        TextField('description',
            accessor="""Description""",
            searchable=1,
            widget=TextAreaWidget
            (description="""An administrative summary of the content""",
                description_msgid='RichDocument_help_description',
                i18n_domain='RichDocument',
                label="""Description""",
                label_msgid='RichDocument_label_description',
            ),
        ),
        
        TextField('body',
            allowable_content_types=('text/html', 'text/structured', 'text/restructured', 'text/plain'),
            default_content_type="""text/structured""",
            default_output_type='text/html',
            primary=1,
            required=1,
            searchable=1,
            widget=RichWidget
            (description="""The body text of the document""",
                description_msgid='RichDocument_help_body',
                i18n_domain='RichDocument',
                label="""Body""",
                label_msgid='RichDocument_label_body',
                rows=20,
            ),
        ),
        
        IntegerField('displayImages',
            default=1,
            enforceVocabulary=1,
            vocabulary=DisplayList((        ('0', 'No preview'),        ('1', 'Display first image floating'),        ('2', 'Display thumbnail box'),        )),
            widget=ImagesManagerWidget
            (description="""The document can automatically display the uploaded images, either by floating the topmost image at the top left of the page, or by display a box of thumbnails the viewer can click on to view the full image in a pop-up window""",
                description_msgid='RichDocument_help_displayImages',
                i18n_domain='RichDocument',
                label="""Display images preview box""",
                label_msgid='RichDocument_label_displayImages',
            ),
        ),
        
    ),
    )

    #Methods


    # uncomment lines below when you need
    factory_type_information={
        'allowed_content_types':allowed_content_types,
        'allow_discussion': 0,
        'content_icon':'RichDocument.gif',
        'immediate_view':'base_view',
        'global_allow':1,
        'filter_content_types':1,
        }

        
    actions=  (
        

          )
        

registerType(RichDocument)
# end of class RichDocument

##code-section module-footer #fill in your manual code here
##/code-section module-footer


